Bug 170652 - test262: test262/test/built-ins/Array/S15.4.3_A2.2.js
Summary: test262: test262/test/built-ins/Array/S15.4.3_A2.2.js
Status: RESOLVED FIXED
Alias: None
Product: WebKit
Classification: Unclassified
Component: JavaScriptCore (show other bugs)
Version: WebKit Nightly Build
Hardware: Unspecified Unspecified
: P2 Normal
Assignee: Joseph Pecoraro
URL:
Keywords:
Depends on:
Blocks:
 
Reported: 2017-04-09 00:57 PDT by Joseph Pecoraro
Modified: 2017-04-11 09:38 PDT (History)
8 users (show)

See Also:


Attachments
[PATCH] Proposed Fix (21.88 KB, patch)
2017-04-09 01:39 PDT, Joseph Pecoraro
no flags Details | Formatted Diff | Diff
[PATCH] Proposed Fix (23.38 KB, patch)
2017-04-09 01:46 PDT, Joseph Pecoraro
buildbot: commit-queue-
Details | Formatted Diff | Diff
Archive of layout-test-results from ews112 for mac-elcapitan (1.84 MB, application/zip)
2017-04-09 02:43 PDT, Build Bot
no flags Details
Archive of layout-test-results from ews101 for mac-elcapitan (974.02 KB, application/zip)
2017-04-09 02:50 PDT, Build Bot
no flags Details
Archive of layout-test-results from ews106 for mac-elcapitan-wk2 (941.59 KB, application/zip)
2017-04-09 02:54 PDT, Build Bot
no flags Details
Archive of layout-test-results from ews121 for ios-simulator-wk2 (914.78 KB, application/zip)
2017-04-09 03:18 PDT, Build Bot
no flags Details
[PATCH] Proposed Fix (28.85 KB, patch)
2017-04-09 12:31 PDT, Joseph Pecoraro
no flags Details | Formatted Diff | Diff
[PATCH] Proposed Fix (29.03 KB, patch)
2017-04-09 12:44 PDT, Joseph Pecoraro
buildbot: commit-queue-
Details | Formatted Diff | Diff
[PATCH] Proposed Fix (29.60 KB, patch)
2017-04-10 22:55 PDT, Joseph Pecoraro
no flags Details | Formatted Diff | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Joseph Pecoraro 2017-04-09 00:57:36 PDT
Summary:
Array.length should be configurable (can be deleted)

Test:
test262/test/built-ins/Array/S15.4.3_A2.2.js

Basically:
delete Array.length;
assert( !Array.hasOwnProperty("length") )

Spec:
https://tc39.github.io/ecma262/#sec-array-constructor

> The length property of the Array constructor function is 1.

https://tc39.github.io/ecma262/#sec-ecmascript-standard-built-in-objects

> Unless otherwise specified, the length property of a built-in function
> object has the attributes { [[Writable]]: false, [[Enumerable]]: false, [[Configurable]]: true }.

Notes:
- Chrome and Firefox pass this test
Comment 1 Joseph Pecoraro 2017-04-09 01:37:09 PDT
This affected a whole bunch of other native constructors as well:

    Array, Boolean, Date, Function, ArrayBuffer,
    Number, Object, RegExp, String, Symbol

Note to WebAssembly folks, those constructor are probably problematic as well but they aren't defined in ecma 262 so I didn't check / change them.
Comment 2 Joseph Pecoraro 2017-04-09 01:39:07 PDT
Created attachment 306609 [details]
[PATCH] Proposed Fix
Comment 3 Joseph Pecoraro 2017-04-09 01:46:23 PDT
Created attachment 306610 [details]
[PATCH] Proposed Fix

This include a little cleanup of unnecessary comments.
Comment 4 Build Bot 2017-04-09 02:22:54 PDT
Comment on attachment 306610 [details]
[PATCH] Proposed Fix

Attachment 306610 [details] did not pass jsc-ews (mac):
Output: http://webkit-queues.webkit.org/results/3504964

New failing tests:
ChakraCore.yaml/ChakraCore/test/es5/enumerable.js.default
Comment 5 Build Bot 2017-04-09 02:43:01 PDT
Comment on attachment 306610 [details]
[PATCH] Proposed Fix

Attachment 306610 [details] did not pass mac-debug-ews (mac):
Output: http://webkit-queues.webkit.org/results/3504981

New failing tests:
sputnik/Conformance/15_Native_Objects/15.4_Array/15.4.3/S15.4.3_A2.2.html
ietestcenter/Javascript/15.3.3.2-1.html
ietestcenter/Javascript/15.2.3.3-4-186.html
ietestcenter/Javascript/15.2.3.3-4-191.html
sputnik/Conformance/15_Native_Objects/15.9_Date/15.9.5/15.9.5.1_Date.prototype.constructor/S15.9.5.1_A3_T2.html
ietestcenter/Javascript/15.2.3.3-4-194.html
ietestcenter/Javascript/15.2.3.3-4-201.html
Comment 6 Build Bot 2017-04-09 02:43:03 PDT
Created attachment 306612 [details]
Archive of layout-test-results from ews112 for mac-elcapitan

The attached test failures were seen while running run-webkit-tests on the mac-debug-ews.
Bot: ews112  Port: mac-elcapitan  Platform: Mac OS X 10.11.6
Comment 7 Build Bot 2017-04-09 02:49:59 PDT
Comment on attachment 306610 [details]
[PATCH] Proposed Fix

Attachment 306610 [details] did not pass mac-ews (mac):
Output: http://webkit-queues.webkit.org/results/3505022

New failing tests:
sputnik/Conformance/15_Native_Objects/15.4_Array/15.4.3/S15.4.3_A2.2.html
ietestcenter/Javascript/15.3.3.2-1.html
ietestcenter/Javascript/15.2.3.3-4-186.html
ietestcenter/Javascript/15.2.3.3-4-191.html
sputnik/Conformance/15_Native_Objects/15.9_Date/15.9.5/15.9.5.1_Date.prototype.constructor/S15.9.5.1_A3_T2.html
ietestcenter/Javascript/15.2.3.3-4-194.html
ietestcenter/Javascript/15.2.3.3-4-201.html
Comment 8 Build Bot 2017-04-09 02:50:00 PDT
Created attachment 306613 [details]
Archive of layout-test-results from ews101 for mac-elcapitan

The attached test failures were seen while running run-webkit-tests on the mac-ews.
Bot: ews101  Port: mac-elcapitan  Platform: Mac OS X 10.11.6
Comment 9 Build Bot 2017-04-09 02:54:46 PDT
Comment on attachment 306610 [details]
[PATCH] Proposed Fix

Attachment 306610 [details] did not pass mac-wk2-ews (mac-wk2):
Output: http://webkit-queues.webkit.org/results/3505031

New failing tests:
sputnik/Conformance/15_Native_Objects/15.4_Array/15.4.3/S15.4.3_A2.2.html
ietestcenter/Javascript/15.3.3.2-1.html
ietestcenter/Javascript/15.2.3.3-4-186.html
ietestcenter/Javascript/15.2.3.3-4-191.html
sputnik/Conformance/15_Native_Objects/15.9_Date/15.9.5/15.9.5.1_Date.prototype.constructor/S15.9.5.1_A3_T2.html
ietestcenter/Javascript/15.2.3.3-4-194.html
ietestcenter/Javascript/15.2.3.3-4-201.html
Comment 10 Build Bot 2017-04-09 02:54:48 PDT
Created attachment 306614 [details]
Archive of layout-test-results from ews106 for mac-elcapitan-wk2

The attached test failures were seen while running run-webkit-tests on the mac-wk2-ews.
Bot: ews106  Port: mac-elcapitan-wk2  Platform: Mac OS X 10.11.6
Comment 11 Build Bot 2017-04-09 03:18:15 PDT
Comment on attachment 306610 [details]
[PATCH] Proposed Fix

Attachment 306610 [details] did not pass ios-sim-ews (ios-simulator-wk2):
Output: http://webkit-queues.webkit.org/results/3505056

New failing tests:
sputnik/Conformance/15_Native_Objects/15.4_Array/15.4.3/S15.4.3_A2.2.html
ietestcenter/Javascript/15.3.3.2-1.html
ietestcenter/Javascript/15.2.3.3-4-186.html
ietestcenter/Javascript/15.2.3.3-4-191.html
sputnik/Conformance/15_Native_Objects/15.9_Date/15.9.5/15.9.5.1_Date.prototype.constructor/S15.9.5.1_A3_T2.html
ietestcenter/Javascript/15.2.3.3-4-194.html
ietestcenter/Javascript/15.2.3.3-4-201.html
Comment 12 Build Bot 2017-04-09 03:18:17 PDT
Created attachment 306616 [details]
Archive of layout-test-results from ews121 for ios-simulator-wk2

The attached test failures were seen while running run-webkit-tests on the ios-sim-ews.
Bot: ews121  Port: ios-simulator-wk2  Platform: Mac OS X 10.11.6
Comment 13 Joseph Pecoraro 2017-04-09 12:31:26 PDT
Created attachment 306628 [details]
[PATCH] Proposed Fix
Comment 14 Build Bot 2017-04-09 12:32:26 PDT
Attachment 306628 [details] did not pass style-queue:


ERROR: LayoutTests/ChangeLog:82:  ChangeLog entry has no bug number  [changelog/bugnumber] [5]
Total errors found: 1 in 22 files


If any of these errors are false positives, please file a bug against check-webkit-style.
Comment 15 Joseph Pecoraro 2017-04-09 12:44:43 PDT
Created attachment 306630 [details]
[PATCH] Proposed Fix

Fix ChangeLogs
Comment 16 Build Bot 2017-04-09 13:20:24 PDT
Comment on attachment 306630 [details]
[PATCH] Proposed Fix

Attachment 306630 [details] did not pass jsc-ews (mac):
Output: http://webkit-queues.webkit.org/results/3507301

New failing tests:
ChakraCore.yaml/ChakraCore/test/es5/enumerable.js.default
Comment 17 Joseph Pecoraro 2017-04-09 14:13:39 PDT
> New failing tests:
> ChakraCore.yaml/ChakraCore/test/es5/enumerable.js.default

How do I rebaseline this?
Comment 18 Joseph Pecoraro 2017-04-10 12:10:26 PDT
(In reply to Joseph Pecoraro from comment #17)
> > New failing tests:
> > ChakraCore.yaml/ChakraCore/test/es5/enumerable.js.default
> 
> How do I rebaseline this?

$ jscr JSTests/ChakraCore/test/jsc-lib.js JSTests/ChakraCore/test/es5/enumerable.js > JSTests/ChakraCore/test/es5/enumerable.baseline-jsc
Comment 19 Joseph Pecoraro 2017-04-10 22:55:24 PDT
Created attachment 306779 [details]
[PATCH] Proposed Fix
Comment 20 Michael Saboff 2017-04-11 09:11:03 PDT
Comment on attachment 306779 [details]
[PATCH] Proposed Fix

r=me
Comment 21 WebKit Commit Bot 2017-04-11 09:38:47 PDT
Comment on attachment 306779 [details]
[PATCH] Proposed Fix

Clearing flags on attachment: 306779

Committed r215234: <http://trac.webkit.org/changeset/215234>
Comment 22 WebKit Commit Bot 2017-04-11 09:38:48 PDT
All reviewed patches have been landed.  Closing bug.